<?php
defined('BASEPATH') or exit('No direct script access allowed');

class ControllerPinjamanAktif extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();
        check_not_login();
        if ($this->session->userdata('level') != 7) {
            redirect();
        }
        $this->load->library('encrypt');
        $this->load->library('form_validation');
        $this->load->library('mycustom');
        $this->load->library('pdfgenerator');
        $this->load->library('WhatAppsNotif');
        $this->load->model('marketing/insert_model');
        $this->load->model('marketing/select_model');
        $this->load->model('marketing/update_model');
        $this->set_timezone();
    }
    public function set_timezone()
    {
        date_default_timezone_set("Asia/Jakarta");
    }

    public function index()
    {
        // Data Login
        $data_login            = $this->userlogin->user_login();
        $data_id_login         = $this->session->userdata('isloggedin');
        // Data Isian Konten
        // Tampilkan Jenis Pinjaman
        $pinjaman_aktif        = $this->select_model->vd_PinjamanAktif();
        // echo '<pre>';
        // var_dump($pinjaman_aktif);
        // die;
        $data_jaminan          = $this->select_model->vd_jaminanPinjaman();
        $data = array(
            // Untuk memanggil halaman sesuai menu
            'folder'              => 'kegiatan/aktif',
            'page'                => 'index',
            'judul'               => 'Pinjaman Aktif || Bagian Marketing',
            'data_id_login'       => $data_id_login,
            'data_login'          => $data_login,
            // Isi dalam konten
            'pinjaman_aktif'      => $pinjaman_aktif,
            'data_jaminan'        => $data_jaminan
        );
        $this->load->view('marketing/index', $data);
    }
    // Detail Kontrak pinjaman
    public function kontrak($id)
    {
        // Data Login
        $data_login            = $this->userlogin->user_login();
        $data_id_login         = $this->session->userdata('isloggedin');
        $kontrak_id            = $this->encrypt->decode($id);
        // Rincian Kontrak
        $rincian_kontrak       = $this->db->get_where('p_koperasi_kontrak', ['id' => $kontrak_id])->row_array();
        $data_angsuran         = $this->select_model->vd_angsuran($kontrak_id);
        $sudah_bayar           = $this->select_model->vd_SudahBayarAngsuran($kontrak_id);
        $data_realisasi        = $this->db->get_where('p_koperasi_progres', ['kontrak_id' => $kontrak_id])->row_array();
        $data_jaminan          = $this->db->get_where('p_koperasi_agungan', ['kontrak_id' => $kontrak_id])->row_array();
        $data_anggota          = $this->db->get_where('anggota', ['id' => $rincian_kontrak['anggota_id']])->row_array();
        // echo '<pre>';
        // var_dump($data_angsuran);
        // die;
        $data = array(
            // Untuk memanggil halaman sesuai menu
            'folder'              => 'kontrak',
            'page'                => 'index',
            'judul'               => 'Detail Kontrak Pinjaman || Bagian Marketing',
            'data_id_login'       => $data_id_login,
            'data_login'          => $data_login,
            'data_anggota'        => $data_anggota,
            // Isi dalam konten
            'rincian_kontrak'     => $rincian_kontrak,
            'data_angsuran'       => $data_angsuran,
            'sudah_bayar'         => $sudah_bayar,
            'doc'                 => $data_realisasi,
            'jaminan'             => $data_jaminan,
        );
        $this->load->view('marketing/index', $data);
    }
    // Notifikasi Manual
    public function notifikasi($id)
    {
        // Data Login
        $angsuran_id           = $this->encrypt->decode($id);
        $data_angsuran         = $this->db->get_where('p_koperasi_angsuran', ['id' => $angsuran_id])->row_array();
        $data_kontrak          = $this->db->get_where('p_koperasi_kontrak', ['id' => $data_angsuran['kontrak_id']])->row_array();
        $data_anggota          = $this->db->get_where('anggota', ['id' => $data_kontrak['anggota_id']])->row_array();
        // Merubah data angsuran
        $this->whatappsnotif->notifikasi($angsuran_id, $data_angsuran, $data_kontrak, $data_anggota);

        $this->session->set_flashdata('pesan_berhasil', '<div class="alert alert-success" id="pesan_berhasil" role="alert">Berhasil Memberikan Notifikasi Bayar Angsuran!</div>');
        redirect('marketing/kegiatan/kontrak_pinjaman/' . $this->encrypt->encode($data_kontrak['id']));
    }
    // Pembayaran Angsuran
    // Lancar
    public function bayar_lancar($id)
    {
        // Data Login
        $angsuran_id           = $this->encrypt->decode($id);
        $status_nota            = 'LANCAR';
        $data_angsuran         = $this->db->get_where('p_koperasi_angsuran', ['id' => $angsuran_id])->row_array();
        $data_kontrak          = $this->db->get_where('p_koperasi_kontrak', ['id' => $data_angsuran['kontrak_id']])->row_array();
        $data_aturan           = $this->db->get_where('p_koperasi_aturan', ['id' => $data_kontrak['aturan_id']])->row_array();
        $data_marketing        = $this->db->get_where('sistem_login', ['id' => $data_kontrak['login_id']])->row_array();
        $data_anggota          = $this->db->get_where('anggota', ['id' => $data_kontrak['anggota_id']])->row_array();
        // Merubah data angsuran
        // echo '<pre>'; 
        // var_dump($angsuran_id, $data_angsuran);
        // die;
        $cek_option = $this->db->get_where('sistem_option')->row_array();
        $this->update_model->merubahDataAngsuran($angsuran_id);
        // Menambahkan Nota
        $nomor_invoice               = $data_aturan['produk_id'] . $data_kontrak['id'] . date('ymdhis');
        $this->insert_model->md_NotaAngsuran($status_nota, $angsuran_id, $nomor_invoice, $data_aturan, $data_kontrak);
        $this->_cetakTandaTerima($nomor_invoice, $data_kontrak, $data_angsuran, $data_aturan, $data_marketing, $cek_option, $data_anggota);
        if ($data_angsuran['angs_ke'] == $data_kontrak['tempo_pinjaman']) :
            $this->update_model->pinjamanSelesai($data_kontrak);
            $this->whatappsnotif->NotifLunas($data_kontrak, $cek_option, $data_anggota);
        // $this->_notifLunas($data_kontrak, $cek_option, $data_anggota);
        endif;
        $this->session->set_flashdata('pesan_berhasil', '<div class="alert alert-success" id="pesan_berhasil" role="alert">Berhasil Bayar Angsuran!</div>');
        redirect('marketing/kegiatan/kontrak_pinjaman/' . $this->encrypt->encode($data_kontrak['id']));
    }
    // Macet
    public function bayar_macet($id)
    {
        // Data Login
        $angsuran_id           = $this->encrypt->decode($id);
        $status_nota           = 'TUNGGAKAN';
        $data_angsuran         = $this->db->get_where('p_koperasi_angsuran', ['id' => $angsuran_id])->row_array();
        $data_kontrak          = $this->db->get_where('p_koperasi_kontrak', ['id' => $data_angsuran['kontrak_id']])->row_array();
        $data_aturan           = $this->db->get_where('p_koperasi_aturan', ['id' => $data_kontrak['aturan_id']])->row_array();
        $data_marketing        = $this->db->get_where('sistem_login', ['id' => $data_kontrak['login_id']])->row_array();
        $data_anggota          = $this->db->get_where('anggota', ['id' => $data_kontrak['anggota_id']])->row_array();
        // Merubah data angsuran
        $cek_option = $this->db->get_where('sistem_option')->row_array();
        $this->update_model->merubahDataAngsuran($angsuran_id);
        // Menambahkan Nota
        $nomor_invoice               = $data_aturan['produk_id'] . $data_kontrak['id'] . date('ymdhis');
        $this->insert_model->md_NotaAngsuran($status_nota, $angsuran_id, $nomor_invoice, $data_aturan, $data_kontrak);
        $this->_cetakTandaTerima($nomor_invoice, $data_kontrak, $data_angsuran, $data_aturan, $data_marketing, $cek_option, $data_anggota);
        if ($data_angsuran['angs_ke'] == $data_kontrak['tempo_pinjaman']) :
            $this->update_model->pinjamanSelesai($data_kontrak);
            $this->whatappsnotif->NotifLunas($data_kontrak, $cek_option, $data_anggota);
        // $this->_notifLunas($data_kontrak, $cek_option, $data_anggota);
        endif;
        $this->session->set_flashdata('pesan_berhasil', '<div class="alert alert-success" id="pesan_berhasil" role="alert">Berhasil Bayar Angsuran!</div>');
        redirect('marketing/kegiatan/kontrak_pinjaman/' . $this->encrypt->encode($data_kontrak['id']));
    }
    // Pembayaran Angsuran Beranda
    public function angsuran_bayar($id)
    {
        // Data Login
        $angsuran_id           = $this->encrypt->decode($id);
        $data_angsuran         = $this->db->get_where('p_koperasi_angsuran', ['id' => $angsuran_id])->row_array();
        $data_kontrak          = $this->db->get_where('p_koperasi_kontrak', ['id' => $data_angsuran['kontrak_id']])->row_array();
        $data_aturan           = $this->db->get_where('p_koperasi_aturan', ['id' => $data_kontrak['aturan_id']])->row_array();
        $data_marketing        = $this->db->get_where('sistem_login', ['id' => $data_kontrak['login_id']])->row_array();
        $data_anggota          = $this->db->get_where('anggota', ['id' => $data_kontrak['anggota_id']])->row_array();
        // Merubah data angsuran
        // echo '<pre>';
        // var_dump($angsuran_id, $data_angsuran);
        // die;
        if ($data_angsuran['BELUM']) :
            $status_nota = 'LANCAR';
        else:
            $status_nota = 'TUNGGAKAN';
        endif;
        $cek_option = $this->db->get_where('sistem_option')->row_array();
        $this->update_model->merubahDataAngsuran($angsuran_id);
        // Menambahkan Nota
        $nomor_invoice         = $data_aturan['produk_id'] . $data_kontrak['id'] . date('ymdhis');
        $this->insert_model->md_NotaAngsuran($status_nota, $angsuran_id, $nomor_invoice, $data_aturan, $data_kontrak);
        $this->_cetakTandaTerima($nomor_invoice, $data_kontrak, $data_angsuran, $data_aturan, $data_marketing, $cek_option, $data_anggota);
        if ($data_angsuran['angs_ke'] == $data_kontrak['tempo_pinjaman']) :
            $this->update_model->pinjamanSelesai($data_kontrak);
            $this->whatappsnotif->NotifLunas($data_kontrak, $cek_option, $data_anggota);
        // $this->_notifLunas($data_kontrak, $cek_option, $data_anggota);
        endif;
        $this->session->set_flashdata('pesan_berhasil', '<div class="alert alert-success" id="pesan_berhasil" role="alert">Berhasil Bayar Angsuran!</div>');
        redirect('marketing');
    }
    // Konversi Nota Tanda Terima
    private function _cetakTandaTerima($nomor_invoice, $data_kontrak, $data_angsuran, $data_aturan, $data_marketing, $cek_option, $data_anggota)
    {
        $kd_invoice            = $nomor_invoice;
        $data_invoice          = $this->select_model->getDataInvoice($kd_invoice); // DONE
        $data_rinci            = $this->select_model->getDataInvoiceRinci($kd_invoice);
        $data = array(
            // Data isi konten
            'data_invoice'        => $data_invoice,
            'data_rinci'          => $data_rinci,
            'data_marketing'      => $data_marketing
        );
        // $this->load->view('nota/nota_bayar_arisan', $data_halaman);
        // filename dari pdf ketika didownload
        $file_pdf = 'invoice_' . $kd_invoice;
        // setting paper
        $paper = 'A5';
        //orientasi paper potrait / landscape
        $orientation = "landscape";

        // $this->load->view('nota/nota_bayar_arisan_petugas', $data);
        $html = $this->load->view('document/nota/nota_pinjaman_koperasi_petugas', $data, true);
        $tahun = date('Y');
        $bulan = date('m');
        // run dompdf
        if ($data_aturan['produk_id'] == 121) :
            $lokasi_file = 'assets/invoice/koperasi_mingguan/' . $tahun . '/' . $bulan . '/';
        elseif ($data_aturan['produk_id'] == 122) :
            $lokasi_file = 'assets/invoice/koperasi_dua_mingguan/' . $tahun . '/' . $bulan . '/';
        elseif ($data_aturan['produk_id'] == 123) :
            $lokasi_file = 'assets/invoice/koperasi_bulanan/' . $tahun . '/' . $bulan . '/';
        elseif ($data_aturan['produk_id'] == 124) :
            $lokasi_file = 'assets/invoice/koperasi_musiman/' . $tahun . '/' . $bulan . '/';
        elseif ($data_aturan['produk_id'] == 125) :
            $lokasi_file = 'assets/invoice/anggota_bulanan/' . $tahun . '/' . $bulan . '/';
        elseif ($data_aturan['produk_id'] == 126) :
            $lokasi_file = 'assets/invoice/karyawan_bulanan/' . $tahun . '/' . $bulan . '/';
        endif;
        // Membuat folder
        if (!is_dir($lokasi_file))
            mkdir($lokasi_file, 0777, TRUE);
        // Membuat File
        // Membuat File Baru
        $isi_index = $this->_membuatFileBaruIndex();
        $index_file = $lokasi_file . 'index.html';
        if (!file_exists($index_file)) {
            file_put_contents($index_file, $isi_index);
        }
        $this->pdfgenerator->generate_cetakTandaTerima($html, $file_pdf, $paper, $lokasi_file, $orientation);
        $data_update22     = array(
            'invoice_pdf' => $file_pdf . '.pdf'
        );
        $this->db->where('id', $kd_invoice);
        $this->db->update('nota', $data_update22);
        $data_update23     = array(
            'invoice_pdf' => $file_pdf . '.pdf'
        );
        $this->db->where('id', $data_angsuran['id']);
        $this->db->update('p_koperasi_angsuran', $data_update23);
        $nama_file = $file_pdf . '.pdf';
        $this->whatappsnotif->notifWABuktiInvoice($nama_file, $data_kontrak, $data_angsuran, $lokasi_file, $data_invoice, $cek_option, $data_anggota);
        // $this->_notifWABuktiSetor($nama_file, $data_kontrak, $data_angsuran, $lokasi_file, $data_invoice, $cek_option, $data_anggota);
    }
    // Kode membuat file
    private function _membuatFileBaruIndex()
    {
        $isi_index = <<<HTML
<!DOCTYPE html>
<html>
<head>
    <title>403 Forbidden</title>
</head>
<body>
<p>Directory access is forbidden.</p>
</body>
</html>
HTML;
        return $isi_index;
    }
}

/* End of file ControllerPinjamanAktif.php and path \application\controllers\marketing\kegiatan\ControllerPinjamanAktif.php */